unsigned short kp,i=0,j=0, Taille=0;
char txt[6];
char ValKey[16], ValKey_rev[16];
char  keypadPort at PORTD;
unsigned long Tempo_int=0, ii=0;
char test[16];

unsigned short char_2_int(unsigned short kpp)
{
 unsigned short kp_int=0;
 switch (kpp)
 {
   case  2: kp_int = 1; break; // 1
   case  3: kp_int = 4; break; // 4
   case  4: kp_int = 7; break; // 7
   case  5: kp_int = 0; break; // 0
   case  6: kp_int = 2; break; // 2
   case  7: kp_int = 5; break; // 5
   case  8: kp_int = 8; break; // 8
   case 10: kp_int = 3; break; // 3
   case 11: kp_int = 6; break; // 6
 }
 return   kp_int;
}

unsigned short key_2_val(unsigned short kpp)
{
 unsigned short kp_val=0;
 switch (kpp)
 {
   case  1: kp_val = 67; break; // C/ON: Arret
   case  2: kp_val = 49; break; // 1
   case  3: kp_val = 52; break; // 4
   case  4: kp_val = 55; break; // 7
   case  5: kp_val = 48; break; // 0
   case  6: kp_val = 50; break; // 2
   case  7: kp_val = 53; break; // 5
   case  8: kp_val = 56; break; // 8
   case  9: kp_val = 35; break; // =
   case 10: kp_val = 51; break; // 3
   case 11: kp_val = 54; break; // 6
   case 12: kp_val = 57; break; // 9
   case 13: kp_val = 43; break; // +
   case 14: kp_val = 45; break; // -
   case 15: kp_val = 42; break; // x
   case 16: kp_val = 47; break; // /
 }
 return   kp_val;
}

unsigned long str_2_int(unsigned short *str, unsigned short taille)
{
 unsigned short i_0=0 ;
 double somme_val=0.0,char_val=0.0, i_doub=0.0;

 for (i_0=0; i_0<taille; i_0++)
 {
     char_val=(double)char_2_int(str[i_0]);
     i_doub=(double)i_0;
     somme_val=somme_val+char_val*pow(10.0,i_doub);
 }
 somme_val=somme_val+1;
 return   (unsigned long )somme_val;
}

// LCD module connections
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
// End LCD module connections

void main() {
  Keypad_Init();                           // Initialize Keypad
  ANSEL  = 0;                              // Configure AN pins as digital I/O
  ANSELH = 0;
  TRISE=0;
  PORTE=0x00;
  // Port A en entre
  TRISA=0xFF;
  Lcd_Init();                              // Initialize LCD
  Lcd_Cmd(_LCD_CLEAR);                     // Clear display
  Lcd_Cmd(_LCD_CURSOR_OFF);                // Cursor off
  Lcd_Out(1, 1, "Tempo (ms)  :");                 // Write message text on LCD
  Lcd_Out(2, 1, "=>");

  do 
  {
    do
    {
      do
        // Lecture du clavier
        kp = Keypad_Key_Click();
        //kp = Keypad_Key_Press(); // Test la fonction
      while (!kp);
      
      // Mmorisation de la touche actionne
      ValKey[i]= kp;
      
      // Obtenir la valeur ASCII de la touche
      kp=  key_2_val(kp);
      
      // Affichage de la touche
      Lcd_Chr(2, i+4, kp);
      Taille=i;
      i++;
      if (i+4==16)
         break;
    }while(kp!=67);  // Condition d'Arret

    // Inverser le tableau
    ValKey[Taille]=" ";
    for (j=0;j<Taille; j++)
        ValKey_rev[j]=ValKey[Taille-1-j];

    // Conversion string ==> Int
    Tempo_int=str_2_int(ValKey_rev, Taille);
    
    // Start tempo
    PORTE=0x01;
    Lcd_Cmd(_LCD_CLEAR);
    Lcd_Out(1, 1, "Tempo (ms)  :");
    Lcd_Out(2, 1, "=> Start");

    ii= Tempo_int>>6;
    for (i=0;i<ii; i++)
        Delay_ms(64);
    
    // Arret tempo
    PORTE=0x00;
    kp = 0; i=0;
    Tempo_int=0;
    Lcd_Cmd(_LCD_CLEAR);
    Lcd_Cmd(_LCD_CURSOR_OFF);
    Lcd_Out(1, 1, "Tempo (ms)  :");
    Lcd_Out(2, 1, "=>");
  } while (1);
}